/*
 * EffecTV - Realtime Digital Video Effector
 * Copyright (C) 2001-2006 FUKUCHI Kentaro
 *
 * utils.c: utilities
 *
 */

#include <math.h>
#include "EffecTV.h"
#include "utils.h"

int utils_init(effect*e)
  {
  e->rgb2yuv = rgb2yuv_init();
  e->yuv2rgb = yuv2rgb_init();
  if(image_init(e))
    return -1;
  return 0;
  }

void utils_end(effect*e)
{
	image_end(e);
}

/*
 * HSI color system utilities
 */
static int my_trunc(double f)
{
	int i;

	i=(int)f;
	if(i<0)i=0;
	if(i>255)i=255;
	return i;
}

void HSItoRGB(double H, double S, double I, int *r, int *g, int *b)
{
	double T,Rv,Gv,Bv;

	Rv=1+S*sin(H-2*M_PI/3);
	Gv=1+S*sin(H);
	Bv=1+S*sin(H+2*M_PI/3);
	T=255.999*I/2;
	*r=my_trunc(Rv*T);
	*g=my_trunc(Gv*T);
	*b=my_trunc(Bv*T);
}

/*
 * fastrand - fast fake random number generator
 * Warning: The low-order bits of numbers generated by fastrand()
 *          are bad as random numbers. For example, fastrand()%4
 *          generates 1,2,3,0,1,2,3,0...
 *          You should use high-order bits.
 */
unsigned int fastrand_val;

unsigned int fastrand(effect*e)
{
	return (e->fastrand_val=e->fastrand_val*1103515245+12345);
}

void fastsrand(effect*e,unsigned int seed)
{
	e->fastrand_val = seed;
}
